<?php
#
# Este script revoca el certificado indicado en el formulario. Es una 
# revocacion prioritaria y la emite el operador de la CA, sin necesidad
# de una solicitud previa.
#

include './core.php';

checkAuth("CA");

cabecera (4);

// El siguiente script se encarga de comprobar que los datos
// de un formulario son validos antes de enviarlos.
echo "<script type='text/javascript'>
<!--
function submit_form()
{
  if ( document.revoke_form.crrID.value == ''  ||
       document.revoke_form.crrID.value.search(/[^a-z,A-Z,0-9,\.,_,\@,\/,\-]/i) >= 0)
  {
    alert ('Por favor introduzca un Identificador correcto. Solo puede escribir caracteres de la \'a\' a la \'z\', nmeros y signos\'/\', \'\', \'-\' y \'_\'');
    document.revoke_form.crrID.focus();
    return false;
  }
  document.revoke_form.submit();
  return true;
}
// -->
</script>\n";


// En la variable command guardaremos el estado de la revocacion.
// Dependiendo de su valor, entraremos en una u otra parte del codigo.
$command = $_POST["crr_command"];
$errorCode = "a0";
$status = "revoked-ca";

switch($command) {

   // Por defecto mostramos el formulario en el que se le solicita
   // al usuario los datos del certificado a revocar
   default:
   echo "
      <h1 class='title'>Solicitud de Revocaci&oacute;n de Certificado</h1>
      <form method='post' action='revoke.php' enctype='multipart/form-data' name='revoke_form'>
      <div id='tbox'>
        <h3 class='head_a2b1'>Revocaci&oacute;n</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Identificador</div>
            <div id='tvalue'><input class='form_input' type='text' name='crrID'  size='25' /></div>
          </div>
          <div id='trow'>
            <div id='tname'>C&oacute;digo de solicitud</div>
            <div id='tvalue'><input type='text' name='copa'  size='16' /></div>
          </div>
          <div id='trow'>
            <div id='tname'>Motivo de la revocaci&oacute;n</div>
            <div id='tvalue'><select name='revReason'>";
          while (list (,$content) = each ($revReasons)) {
                echo "<option>$content</option>";
             }
          echo "</select>
            </div>
          </div>
          <div id='trow'>
            <div id='tname'>Comentarios (opcional)</div>
            <div id='tvalue'><input type='text' name='comments'  size='25'></div>
          </div>
        </div>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Pass Phrase:</div>
            <div id='tvalue'><input type='password' name='passPhrase' size='25'></div>
          </div>
          <div id='trow'>
            <div id='tvalue'>
              <input class='button' type='button' value='Continuar' onclick='submit_form()' />
            </div>
          </div>
        </div>
      </div>
      <input type='hidden' name='crr_command' value='crr_process'>
      </form>
   ";

   break;

   case "crr_process":
      // Obtenemos el valor de las variables pasadas en el formulario
      $copa = $_POST['copa'];
      $crrID = $_POST['crrID'];
      $revReason = $_POST['revReason'];
      $comments = $_POST['comments'];
      $passPhrase = $_POST['passPhrase']; 

      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
      $justthese = array("cn", "sn", "pkirisID");
      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
      if ( !$result )
         $errorCode = "a3b3c1d1";
      // Verificamos si existe el codigo del certificado, si el resultado
      // de $result['count'] es 0 no existe, si es 1 si existe.
      else if ( $result['count'] == 0 )  
         $errorCode = "a3b3c2d1";
      // Si existe, tenemos que comprobar si el identificador introducido se corresponde con ese codigo
      else {
         if ($result[0]["pkirisid"][0] != $crrID )
            $errorCode = "a3b3c2d2";
         else {

            // Buscamos la informacion el certificado cuyo numero copa sea 
            // '$copa'
            $filter2 = "(&(objectClass=pkirisCertificate)(pkirisStatus=ca2ra)(pkirisCopaID=$copa))";
            $justthese = array("dn", "pkiriscerttype", "pkirispin");

            $result2 = ldap_get_info($ldapVar['base'], $filter2, $justthese);
            if ( !$result2 )
               $errorCode = "a3b3c1d1";
            else if ( $result2['count'] == 0)
               $errorCode = "a3b3c2d3";
            else {
               // Obtenemos el Certificado del usuario, lo pasamos a un archivo
               // como .der y luego lo pasamos a .txt
               $userCert = ldap_get_cert($ldapVar['base'], $filter2);
               // Si ha habido algun error, mostramos mensaje y no continuamos
               if (!$userCert)
                  $errorCode = "a3b3c1d5";
               else {
                  $type = $result2[0]["pkiriscerttype"][0];
                  $dn = $result2[0]["dn"];

                  echo "<h3>Datos sobre la solicitud de Revocaci&oacute;n (CRR)</h3>
                  <br />
                  <table border='1' cellpadding='2' cellspacing='0'>
                  <tr><td>Identificador</td><td>$crrID</td></tr>
                  <tr><td>C&oacute;digo de solicitud</td><td>$copa</td></tr>";

                  if ($type == "srv")
                     echo "<tr><td>Tipo</td><td>Certificado de Servidor</td></tr>";
                  
                  else 
                     echo "<tr><td>Tipo</td><td>Certificado de Usuario</td></tr>";
                  
                  echo "</table>
                  <br />
                  <h3>Datos sobre el certificado que se va a revocar</h3>
                  <PRE>\n";

                  $derFile = $dirVar['crt'] . $copa.".x509ee";
                  // Verificamos si existe el fichero y si no lo creamos y volcamos la info del certificado en el
                  if (!file_exists($filename)) {
                     $der = fopen($derFile, "w");
                     fputs($der, $userCert[0]);
                     fclose($der);
                  }

                  $txtCert = exec($bin['openssl'] . " x509 -text -inform DER < " .$derFile, $result);

                  for($i = 1; $i < count($result); $i++) 
                     echo "$result[$i]\n";

                  echo "</PRE>";
                  // Tenemos que guardar en el ldap el motivo de la revocacion
                  $updateRevReason["pkirisrevocationreason"] = $revReason;

                  $r = ldap_mod_info ($dn, $updateRevReason);
                  if (!$r) 
                     $errorCode = "a3b3c1d3";
                  else {   
                    echo "<form method='post' action='revoke.php'>
                      <input class='form_submit' type=submit value='Generar petici&oacute;n de revocaci&oacute;n'>
                      <input type='hidden' name='copa' value='$copa'>
                      <input type='hidden' name='dn' value='$dn'>
                      <input type='hidden' name='errorCode'  value='$errorCode'>
                      <input type='hidden' name='comments'  value='$comments'>
                      <input type='hidden' name='crr_reason' value='$revReason'>
		      <input type='hidden' name='passPhrase' value='$passPhrase'/>
                      <input type='hidden' name='crr_command' value='crr_makeXml'>
                      </form>\n";
                  } 
               }
            }
         }
      }
      break;

   case "crr_makeXml":
      $copa = $_POST['copa'];
      $dn = $_POST['dn'];
      $errorCode = $_POST['errorCode'];
      $crr_reason = $_POST['crr_reason'];
      $comments = $_POST['comments'];
      $passPhrase = $_POST['passPhrase'];

      $lastStatus = getStatus($copa);
      if ( !$lastStatus ) 
         $errorCode = "a3b3c2d4";
      // Esta comprobacion se hace para evitar que se escriba dos veces la
      // misma traza y el mismo xml al recargar el navegador
      else if ($lastStatus != "ca2ra") 
         $errorCode = "a3b3c2d8";
      else {
         
         $r = revoke($copa, $status, $passPhrase);
         if ( !$r ) 
            $errorCode = "a3b3c2d5";
         else {
            $currentDate = date("YmdHis");
            $invalidityDate = $currentDate; // En un futuro, esta variable debe tener otro valor

            $traceVals["status"] = $status;
            $traceVals["copa"] = $copa;
            $traceVals["currentDate"] = $currentDate;
            $traceVals["invalidityDate"] = $invalidityDate;
            $traceVals["revocationReason"] = $crr_reason;
            $traceVals["comments"] = $comments;

            // Construimos la urn con los valores especificados en $traceVals
            $pkiTrace =  getTrace ($traceVals);
            if ( !$pkiTrace )
               $errorCode = "a3b3c2d6";
            else {
               // Cambiamos los estados de pkiStatus, pkiDate y pkiRevocationReason
               $updateFields["pkirisstatus"] = $status;
               $updateFields["pkirisdate"] = $currentDate;
               // El numero copa del administrador de la CA sera 'a0b0'
               $updateFields["pkirisrevokedbycopaid"] = "a0b0";
            
               $r=ldap_mod_info($dn, $updateFields);
               if (!$r) 
                  $errorCode = "a3b3c1d3";
               else {
                  // Insertamos la traza en ldap
                  $urn["pkiristrace"] = $pkiTrace;
                  $r=ldap_mod_add_info($dn, $urn);
                  if (!$r) 
                     $errorCode = "a3b3c1d4";
                  else {
                     // Si no ha habido errores, generarmos el fichero XML para enviar los
                     // datos a la RA
                     $r = createXML ( array($copa) );
                     if (!$r)
                        $errorCode = "a3b3c2d7";
                     else {
                        $pkiLog['status'] = "revoke";
                        $pkiLog['eee'] = "none";
                        $pkiLog['user'] = "CA-Admin";
                        $pkiLog['error'] = $errorCode;
                        writeLog($pkiLog);
                        echo "<h1 class='title'>Solicitud de Revocaci&oacute;n</h1><h3> Revocaci&oacute;n Efectuada</h3>
                              <p> Re ha revocado el certificado asociado a los datos introducidos.</p>";

                     }
                  }
               }
            }
         }
      }
      break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h3> Error en la Solicitud de Revocaci&oacute;n </h3>\n";
   $pkiLog['status'] = "revoke";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "CA-Admin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>
